﻿using System;

class BSortApp
{
    static void Main(string[] args)
    {
        int[] dat = { 22, 65, 72, 17, 48, 50, 39, 90, 80 };

        for (int i = 0; i < dat.Length; i++)
            Console.Write("{0,4}", dat[i]);
        Console.WriteLine();

        BasicSort(dat, dat.Length);  //基本的なソート

        for (int i = 0; i < dat.Length; i++)
            Console.Write("{0,4}", dat[i]);
        Console.WriteLine();
    }

    //  以下のコード断片は、C# コンパイラと Java コンパイラのどちらでも有効な実装です。 

    //==== ==== ★★基本的なソート本体★★ ==== ==== 
    //  [] dat ---- ソート対象の配列本体
    //  n      ---- 要素の数(2以上であることが前提)
    private static void BasicSort(int[] dat, int n) {
        for (int j = 0; j < n - 1; j++) {
            int minpos = j;
            for (int k = j + 1; k < n; k++) {
                if (dat[minpos] > dat[k])
                    minpos = k;
            }
            int w = dat[j];
            dat[j] = dat[minpos];
            dat[minpos] = w;
        }
    }

    //==== ==== ★★ ★★ ==== ==== 

}

