﻿using System;

class ISortApp
{
    static void Main(string[] args)
    {
        int[] dat = { 22, 65, 72, 17, 48, 50, 39, 90, 80 };

        for (int i = 0; i < dat.Length; i++)
            Console.Write("{0,4}", dat[i]);
        Console.WriteLine();

        InsertSort(dat, dat.Length);  //挿入ソート

        for (int i = 0; i < dat.Length; i++)
            Console.Write("{0,4}", dat[i]);
        Console.WriteLine();
    }

    //  以下のコード断片は、C# コンパイラと Java コンパイラのどちらでも有効な実装です。 

    //==== ==== ★★挿入ソート本体★★ ==== ==== 
    //  [] dat ---- ソート対象の配列本体
    //  n      ---- 要素の数
    private static void InsertSort(int[] dat, int n) {
        for (int p = 1; p < n; p++) {
            for (int j = p; j - 1 >= 0; j--) {
                if (dat[j - 1] > dat[j]) {
                    int w = dat[j - 1];
                    dat[j - 1] = dat[j];
                    dat[j] = w;
                }
                else
                    break;
            }
        }
    }
    //==== ==== ★★ ★★ ==== ==== 
}
