class BSTreeApp {

    public static void main(String[] args) {
        // ǉ
        BSTreeAdd(new Node(50, 100));
        BSTreeAdd(new Node(22, 200));
        BSTreeAdd(new Node(72, 300));
        BSTreeAdd(new Node(17, 400));
        BSTreeAdd(new Node(39, 500));
        BSTreeAdd(new Node(48, 600));
        BSTreeAdd(new Node(65, 700));
        BSTreeAdd(new Node(90, 800));
        BSTreeAdd(new Node(80, 900));

        // _v
        for (int i = 1; i <= 4; i++) {
            Dump(root, i);
            System.out.println();
        }

        int key;
        Node hit;
        int result;

        // T
        key = 48;
        hit = BSTreeSearch(root, key);  //񕪒T؂ɂT(u48vT)
        if (hit == null)
            System.out.println("target=" + key + " ͂܂B");
        else
            System.out.println("target=" + hit.code + " ̉i " +
                               hit.price + "łB");

        // 폜
        result = BSTreeDelete(50);
        if (result < 0)
            System.out.println("50 ̍폜Ɏs܂B");
        result = BSTreeDelete(79);
        if (result < 0)
            System.out.println("79 ̍폜Ɏs܂B");

        // _v
        for (int i = 1; i <= 4; i++) {
            Dump(root, i);
            System.out.println();
        }

        // T
        key = 48;
        hit = BSTreeSearch(root, key);  //񕪒T؂ɂT(u48vT)
        if (hit == null)
            System.out.println("target=" + key + " ͂܂B");
        else
            System.out.println("target=" + hit.code + " ̉i " +
                               hit.price + "łB");

        // 폜
        result = BSTreeDelete(48);
        if (result < 0)
            System.out.println("48 ̍폜Ɏs܂B");

        // _v
        for (int i = 1; i <= 4; i++) {
            Dump(root, i);
            System.out.println();
        }

        // T
        key = 48;
        hit = BSTreeSearch(root, key);  //񕪒T؂ɂT(u48vT)
        if (hit == null)
            System.out.println("target=" + key + " ͂܂B");
        else
            System.out.println("target=" + hit.code + " ̉i " +
                               hit.price + "łB");

        // 폜
        BSTreeDelete(22);
        BSTreeDelete(72);
        BSTreeDelete(17);
        BSTreeDelete(39);
        BSTreeDelete(65);
        BSTreeDelete(90);
        BSTreeDelete(80);

        //
        System.out.println(root == null);
    }

    //eXgpKw_v
    private static void Dump(Node node, int level) {
        level--;
        if (level == 0) {
            System.out.print( (node == null) ? "* " : node.code + " ");
            return;
        }
        else {
            if (node == null) return;
            Dump(node.left, level);
            Dump(node.right, level);
        }
    }

    //  ȉ̃R[hfЂ́AJava RpC C# RpĈǂłLȎłB 

    //==== ==== 񕪒T؂ɂT{́ ==== ==== 
    private static Node root = null;   //[gm[h

    //T
    //  r ---- T̋N_m[h
    //  target ---- R[h(code)
    //  ߂l ---- qbgm[h(YȂꍇnull)
    private static Node BSTreeSearch(Node root, int target) {
        if (root == null) //[gΊYȂ
            return null;

        for (Node p = root; p != null; ) { //݂̌Ώۃm[h\ p  null ɂȂ܂ŌJԂ
            if (p.code == target)
                return p;           //oďI
            else if (p.code > target)
                p = p.left;         //ɐi
            else
                p = p.right;        //Eɐi
        }

        return null; //YȂƂ null ԂďI
    }

    //ǉ
    //  q      ---- ǉm[h
    //  ߂l ---- IȂ 0A̒l͉炩̃G[R[h
    private static int BSTreeAdd(Node q) {
        if (root == null) { //[gȂ΃[gɂďI
            root = q;
            return 0;
        }

        int target = q.code;
        for (Node p = root; ; ) { //󂫂܂Ői߂Ēǉ
            if (p.code == target)
                return -1;             //dG[ƂăG[I
            else if (p.code > target) {
                if (p.left == null) {  //̋󂫊mF
                    p.left = q;
                    return 0;
                }
                else
                    p = p.left;        //ɐi
            }
            else {
                if (p.right == null) { //E̋󂫊mF
                    p.right = q;
                    return 0;
                }
                else
                    p = p.right;       //Eɐi
            }
        }
    }

    //폜
    //  target ---- 폜m[h̃R[h
    //  ߂l ---- IȂ 0A̒l͉炩̃G[R[h
    private static int BSTreeDelete(int target) {
        if (root == null) {  //[gȂ΃G[I
            return -1;       //YȂ
        }

        if (root.code == target) { //[gňvꍇA[g̐ȅC͕svȂ̂ŁAPɂ̃m[h牺̏C
            root = DeleteAndNewSubTree(root);
            return 0;
        }

        //܂Ŏsłꍇ́Aroot폜ΏۂłȂ

        for (Node parent = root; ; ) { //vm[hč폜AvƂAparent͂̐em[h

            //ȉ̕]ł́Aparent.code == target ͂肦Ȃ
            //ɂЂƂO̕]ɂāAvȂƂmF̂
            
            if (parent.code > target) {
                if (parent.left == null)   //ɐi߂邩mF
                    return -1;             //YȂ
                else {
                    if (parent.left.code == target) { //m[h͈v邩
                        //v폜A̐ẽ|C^C
                        parent.left = DeleteAndNewSubTree(parent.left);
                        return 0;
                    }
                    else {
                        //vȂAPɍɐi
                        parent = parent.left;
                        continue;
                    }
                }
            }
            else {
                if (parent.right == null)  //Eɐi߂邩mF
                    return -1;             //YȂ
                else {
                    if (parent.right.code == target) { //Em[h͈v邩
                        //v폜A̐ẽ|C^C
                        parent.right = DeleteAndNewSubTree(parent.right);
                        return 0;
                    }
                    else {
                        //vȂAPɉEɐi
                        parent = parent.right;
                        continue;
                    }
                }
            }
        }
    }

    //m[h폜A̋󂫃m[h𖄂߂悤ɁA
    //폜m[h̔zɂqm[ĥꂩičč\z
    //č\zɂĎcc[Ԃ
    //ۂɕԂ̂́AVɏiĂqm[hgbvƂTuc[
    private static Node DeleteAndNewSubTree(Node p) {
        if (p.left == null) {
            if (p.right == null) {
                //̎qm[hȂꍇAԂׂc[͂Ȃ̂ null Ԃ
                return null;
            }
            else {
                //EꍇAEi邽ߕԂ(EVTuc[̃gbv)
                return root.right;
            }
        }
        else {
            if (root.right == null) {
                //ꍇAi邽ߕԂ(EVTuc[̃gbv)
                return root.left;
            }
            else {
                //̎qm[hꍇATuc[̍őli
                Node right = p.right;              //݂̉Eޔ
                p = ExtractMaxAndRebuild(p.left);  //Tuc[̍őli
                p.right = right;                   // ޔĂETuc[Đݒ
                return p;
            }
        }
    }


    //m[hƂ(gbvƂ)Tuc[̒ŁAől̃m[hoA
    //ꂪgbvɂȂ悤Ãgbv̐eɂȂ悤č\z
    //Vgbv߂lƂĕԂ
    //ȂAőlłm[hgbvɂȂ̂ŁÃgbv̉E͋󂫃m[hƂȂ
    private static Node ExtractMaxAndRebuild(Node r) {
        Node p, parent;
        for (p = r, parent = null;
             p.right != null; parent = p, p = p.right) ;  // E̋󂫂܂Ői߂
        // iލۂɁAem[hޔ
        //̎_ōől̓m[h p
        //̐éAparent

        if (parent != null) {      //eΐe폜A̓gbvɐeɂȂ
                                   //eȂ΁A p c[̃gbvȂ̂ŉȂ
            parent.right = null;
            p.left = r;
        }

        return p;                 //ől p Ԃ
    }
    //==== ====   ==== ==== 

}
