class HSortApp {

    public static void main(String[] args) {
        int[] dat = { 22, 65, 72, 17, 48, 50, 39, 90, 80 };

        for (int i = 0; i < dat.length; i++)
            System.out.print(dat[i] + "  ");
        System.out.println();

        HeapSort(dat, dat.length);   //q[v\[g

        for (int i = 0; i < dat.length; i++)
            System.out.print(dat[i] + "  ");
        System.out.println();
   }

    //  ȉ̃R[hfЂ́AJava RpC C# RpĈǂłLȎłB 

    //==== ==== q[v\[g{́ ==== ====
    //  [] dat ---- \[gΏۂ̔z{
    //  n      ---- vf̐(2ȏł邱ƂO)
    private static void HeapSort(int[] dat, int n) {
        //q[v̍쐬
        InitHeap(dat, n);
        //gbvȂAq[vAq[vC
        for (int size = n; size >= 2; ) {
            // gbv̒lz̖ƌ
            int w = dat[size - 1];  //z̓Y̓[n܂̂ŕ␳
            dat[size - 1] = dat[0];
            dat[0] = w;
            // q[vďC
            size--;
            RebuildHeap(dat, 0, size - 1);
        }
    }

    //q[v̍쐬
    //  [] dat ---- \[gΏۂ̔z{
    //  n      ---- q[vƂĎgpvf
    private static void InitHeap(int[] dat, int n) {
        for (int k = n / 2; k >= 1; k--) {
            // ₷邽߁AevZɂ͑̏璷܂

            // eƍE̎q̈ʒu߂(Y0n܂̂ 1Z)
            int parent = k - 1;           // e
            int left = (k * 2) - 1;       // ̎q
            int right = (k * 2 + 1) - 1;  // E̎q

            // eƓ̎qŔr
            int winner = Battle(dat, parent, left, right, n - 1);
            if (parent == winner) //e҂ȂΉɁÃm[h̕]
                continue;
            else {                //q҂ȂΌ
                // dat[parent]  dat[winner] 
                int w = dat[parent];
                dat[parent] = dat[winner];
                dat[winner] = w;
                // ꉺʂɗVȐëʒu(winner)gbvƂāAq[vC
                RebuildHeap(dat, winner, n - 1);
            }
        }
    }
    
    //q[vw肵gbvC
    //  [] dat ---- \[gΏۂ̔z{
    //  top    ---- Cgbv̈ʒu(0n܂z̓Y)
    //  bottom ---- q[vƂĎgp͈͂̏I[(0n܂z̓Y)
    private static void RebuildHeap(int[] dat, int top, int bottom) {
        int k = top + 1;          //}ɍ킹邽߂ɁA1n܂ϐ k gp
        int size = bottom + 1;    //}ɍ킹邽߂ɁA1n܂q[vI[\ϐ size gp
        int parent, left, right;  //ëʒuA̎q̈ʒuAE̎q̈ʒu (ǂY 0 n܂邱ƂO)

        // eƍE̎q̈ʒu߂(Y0n܂̂ 1Z)
        parent = k - 1;
        left = (k * 2) - 1;
        right = (k * 2 + 1) - 1;

        // eƓ̎qŔr
        int winner = Battle(dat, parent, left, right, bottom);
        if (parent == winner) //e҂ȂΉɏI
            return;
        else {                //q҂ȂΌ
            int w = dat[parent];
            dat[parent] = dat[winner];
            dat[winner] = w;
            // ꉺʂɗVȐëʒugbvƂāAq[vC
            RebuildHeap(dat, winner, size - 1);
        }
    }

    //eƓ̎q]A҂̈ʒuԂ(z̓Y)
    //  [] dat        ---- \[gΏۂ̔z{
    //  parent        ---- ëʒu
    //  left  right ---- E̎q̈ʒu
    //  bottom        ---- q[vƂĎgp͈͂̏I[
    private static int Battle(int[] dat, int parent, int left, int right, int bottom) {
        if (left > bottom)  //̈ʒuq[vOȂ΁A̎q͂Ȃ̂ŁAȅ
            return parent;

        // ̎_ŏȂƂ̎q݂͑

        // E̎q̑Ό
        int childWinner;    //Ê̏҂̓Y
        if (right > bottom)                //Ëʒuq[vOȂ΁A̎q̏
            childWinner = left;
        else if (dat[left] >= dat[right])  //̎qȂAEr
            childWinner = left;            //̏
        else
            childWinner = right;           //Ȅ

        // ŌɐeƑΌ
        if (dat[parent] >= dat[childWinner])
            return parent;       // ȅ
        else
            return childWinner;  // ҂̎q̏
    }
    //==== ====   ==== ==== 
}
